(ns clojureDemo.appeture)

(use 'clojure.contrib.repl-utils)
(use 'clojure.contrib.accumulators)

"right now this only will work on odd square arrays"

(def rrr {[0 0] 20 , [1 0] 20, [2 0] 20
	  [0 1]  0 , [1 1]  0, [2 1]  0
	  [0 2]  0 , [1 2]  0, [2 2]  0})

(def rrrr {[0 0] 20 , [1 0] 20, [2 0] 20 , [3 0] 20, [4 0] 20,
	   [0 1] 20 , [1 1] 20, [2 1] 20 , [3 1] 20, [4 1] 20,
	   [0 2]  0 , [1 2]  0, [2 2]  0 , [3 2] 0,  [4 2] 0,
	   [0 3]  0 , [1 3]  0, [2 3]  0 , [3 3] 0,  [4 3] 0,
	   [0 4]  0 , [1 4]  0, [2 4]  0 , [3 4] 0,  [4 4] 0,})

(defn vector-mul
  [mul vect]
  (apply vector (map #(* mul %) vect)) )

(defn vector-sum
  ([] 0)
  ([& args] 
  (apply vector (reduce #(map + %1 %2) args))))

(defn vector-sub
  [vector1 vector2]
  (vector-sum vector1 (vector-mul -1 vector2)))
 
(defn vector-dot
  [vector1 vector2]
  (reduce + (map * vector1 vector2)))

(defn center
  [window]
  (let [coords (keys window)]
  (vector-mul (/ 1 (count coords)) (apply vector-sum coords))))

(defn window-segmentate
  [window line]
  (let [center (center window)]
  (letfn [(path   [window] (filter (fn [point] (apply = (line center point))) (keys window)))
	  (top    [window] (filter (fn [point] (apply > (line center point))) (keys window)))
	  (bottom [window] (filter (fn [point] (apply < (line center point))) (keys window)))]
     {:top (top window) :bottom (bottom window) :line (path window)})))

(defn diag1
  [window]
  (window-segmentate window (fn [center point] (list (first  (vector-sub point center)) (-(last  (vector-sub point center)))))))

(defn diag2
  [window]
(window-segmentate window  (fn [center point] (list (first (vector-sub point center)) (last  (vector-sub point center))))))
 
(defn vert
  [window]
(window-segmentate window  (fn [center point] (list (first (vector-sub point center)) 0))))
 
(defn horiz
  [window]
(window-segmentate window  (fn [center point] (list 0 (last (vector-sub point center))))))


 

 

(defn lines
  [window]    
    (let [lines (list (vert window) (horiz window) (diag1 window) (diag2 window))]
      lines))
;This is the wrong model.  Higher level processors should set these paramaters, and 
; juggle them around if they aren't getting anything they understand.



(defn stats-base
  [sections window sel-fun]
 (let [stats-top    (add-items empty-mean-variance (map window (:top sections)))
	stats-bottom (add-items empty-mean-variance (map window (:bottom sections)))]
   (let [ var1 (:variance stats-top) mean1 (:mean stats-top) var2 (:variance stats-bottom) mean2 (:mean stats-bottom)]
     (sel-fun var1 mean1 var2 mean2))))

(defn window-line
  [window transformation detection]
  (let [x-window (transformation window)]
    (first (filter #(stats-base % x-window detection) (lines x-window)))))
	       
(defn window-stats
  ([window] (window-stats window identity))
  ([window transformation]
  (let [x-window (transformation window)]
    (map (fn [line] (stats-base line x-window #(list %1 %2 %3 %4))) (lines x-window)))))




(comment 

(do (use :reload-all 'clojureDemo.appeture) (in-ns 'clojureDemo.appeture))

)
